lsb conform init script: return code for non-installed
[darcs-mirror-metainit.git] / utils / create-sysvinit-file
1 #!/usr/bin/perl -w
2 #
3 # Creates a sysvinit file from a metainit description.
4 #
5
6 #
7 # Note that we’d like to adhere the LSB, so see
8 # http://refspecs.freestandards.org/LSB_2.1.0/LSB-generic/LSB-generic/iniscrptact.html
9 #
10
11 use MetaInit::Parse;
12
13 $filename = shift || die "Useage: $0 <filename>\n";
14 my $output = shift;
15
16 # Parse the metainit in
17 %initparams = %{MetaInit::Parse::parse({ filename => $filename })};
18
19 if ($output) {
20     open(STDOUT,'>',$output) or die "Can't open '$output': $!";
21 }
22
23 # Print the "dynamic" part of the initscript
24
25 my $rl_start = join " ", @{$initparams{"Start-Levels"}};
26 my $rl_stop  = join " ", @{$initparams{"Stop-Levels"}};
27
28 print << "EOF";
29 #! /bin/sh
30 #
31 # This a generated file. DO NOT EDIT THIS FILE!
32 # If you want to modify how this file works, please
33 # modify $filename and re-run update-metainit.
34 #
35 # If you are sure that you want to modify this file,
36 # remove this comment, and update-metainit will not override
37 # this script any more.
38 #
39 ### BEGIN INIT INFO
40 # Provides:          $initparams{"Name"}
41 # Default-Start:     $rl_start
42 # Default-Stop:      $rl_stop
43 # Short-Description: $initparams{"Short-Description"}
44 EOF
45
46 print "# Required-Start:   " . join(" ",@{$initparams{"Required-Start"}}) . "\n";
47 print "# Required-Stop:     " . join(" ",@{$initparams{"Required-Stop"}}) . "\n";
48 print "# Description:       ";
49 print join("\n#                    ",split("\n",$initparams{"Description"})). "\n";
50 print "\n";
51
52 # prevent quoted strings from breaking the generated script:
53
54 my %quoted_initparams;
55
56 while (my ($k, $v) = each %initparams){
57     $quoted_initparams{$k} = quotemeta ($v || '');
58 }
59
60 print << "EOF"
61 ### END INIT INFO
62
63 # PATH should only include /usr/* if it runs after the mountnfs.sh script
64 PATH=/sbin:/usr/sbin:/bin:/usr/bin
65 DESC=$quoted_initparams{"Short-Description"}
66 NAME=$quoted_initparams{"Name"}
67 DAEMON=$initparams{"Path"}
68 BASENAME=$initparams{"Basename"}
69 DAEMON_ARGS=$quoted_initparams{"Args"}
70 PIDFILE=/var/run/\$NAME.pid
71 SCRIPTNAME=/etc/init.d/\$NAME
72 EOF
73 ;
74
75 # ... and the rest of the initscript, that is identical for all
76 # metainit-created scripts.
77 print << 'EOF'
78 # Exit if the package is not installed
79 [ -x "$DAEMON" ] || exit 5
80
81 # Read configuration variable file if it is present
82 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
83
84 # Load the VERBOSE setting and other rcS variables
85 . /lib/init/vars.sh
86
87 # Define LSB log_* functions.
88 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
89 . /lib/lsb/init-functions
90
91 #
92 # Function that starts the daemon/service
93 #
94 do_start()
95 {
96 EOF
97 ;
98
99 if($initparams{"Prestart-Hook"}) {
100     print "\t" . join("\n\t",split("\n",$initparams{"Prestart-Hook"}));
101     print "\n";
102 }
103
104 print << 'EOF'
105         # Return
106         #   0 if daemon has been started
107         #   1 if daemon was already running
108         #   2 if daemon could not be started
109         start-stop-daemon --start --background --quiet --make-pidfile --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
110                 || return 1
111         start-stop-daemon --start --background --quiet --make-pidfile --pidfile $PIDFILE --exec $DAEMON -- \
112                 $DAEMON_ARGS \
113                 || return 2
114         # Add code here, if necessary, that waits for the process to be ready
115         # to handle requests from services started subsequently which depend
116         # on this one.  As a last resort, sleep for some time.
117 }
118
119 #
120 # Function that stops the daemon/service
121 #
122 do_stop()
123 {
124         # Return
125         #   0 if daemon has been stopped
126         #   1 if daemon was already stopped
127         #   2 if daemon could not be stopped
128         #   other if a failure occurred
129         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $BASENAME
130         RETVAL="$?"
131
132         rm -f $PIDFILE
133
134         return $RETVAL
135 EOF
136 ;
137
138 if($initparams{"Poststop-Hook"}) {
139     print "\t" . join("\n\t",split("\n",$initparams{"Poststop-Hook"}));
140     print "\n";
141 }
142
143 print << 'EOF';
144         return "$RETVAL"
145 }
146
147 #
148 # Function that sends a SIGHUP to the daemon/service
149 #
150 do_reload() {
151         #
152         # If the daemon can reload its configuration without
153         # restarting (for example, when it is sent a SIGHUP),
154         # then implement that here.
155         #
156         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
157         return 0
158 }
159
160 case "$1" in
161   start)
162         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
163         do_start
164         case "$?" in
165                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
166                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
167         esac
168         ;;
169   stop)
170         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
171         do_stop
172         case "$?" in
173                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
174                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
175         esac
176         ;;
177   #reload|force-reload)
178         #
179         # If do_reload() is not implemented then leave this commented out
180         # and leave 'force-reload' as an alias for 'restart'.
181         #
182         #log_daemon_msg "Reloading $DESC" "$NAME"
183         #do_reload
184         #log_end_msg $?
185         #;;
186   restart|force-reload)
187         #
188         # If the "reload" option is implemented then remove the
189         # 'force-reload' alias
190         #
191         log_daemon_msg "Restarting $DESC" "$NAME"
192         do_stop
193         case "$?" in
194           0|1)
195                 do_start
196                 case "$?" in
197                         0) log_end_msg 0 ;;
198                         1) log_end_msg 1 ;; # Old process is still running
199                         *) log_end_msg 1 ;; # Failed to start
200                 esac
201                 ;;
202           *)
203                 # Failed to stop
204                 log_end_msg 1
205                 ;;
206         esac
207         ;;
208   *)
209         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
210         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
211         exit 3
212         ;;
213 esac
214 EOF
215
216 if ($output) {
217     close STDOUT;
218     chmod 0755, $output or die "Can't change permissions for '$output': $!";
219 }
220
221 # vim: ts=4:sw=4:expandtab